/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mavenjson;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.stream.Collectors;
import org.json.JSONArray;
import org.json.JSONObject;

/**
 *
 * @author :)
 */
public class Pelda {
    
    private String fajlEleres = "/adatok/adatok.json";
    
    public static void main(String[] args) {
            new Pelda().indit();
    }
    private String CHAR_SET = "UTF-8";
    private List<Szemely> szemelyek = new ArrayList<>();
  
    private void indit() {
        
        try {
            beolvasas();
            kiiratas();
        } catch (IOException ex) {
            Logger.getLogger(Pelda.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private void beolvasas() throws IOException {

        try (InputStream stream = this.getClass().getResourceAsStream(fajlEleres);
                BufferedReader reader = new BufferedReader(new InputStreamReader(stream, CHAR_SET))) {
            String adat = reader.lines().collect(Collectors.joining("\n"));
            JSONObject jsonObj = new JSONObject(adat);
            JSONArray jSONArray = jsonObj.getJSONArray(Szemely.CSOMOPONT_NEV);
            JSONObject temp;
            String nev;
            int szulEv;

            Cim cim;
            List<Telefon> telefonok;
            Szemely szemely;
            for (int i = 0; i < jSONArray.length(); i++) {
                temp = jSONArray.getJSONObject(i);
                nev = temp.getString(Szemely.ELNEVEZES_NEV);
                szulEv = temp.getInt(Szemely.SZUL_EV_NEV);

                cim = cimLetrehozas(temp);                

                szemely = new Szemely(nev, szulEv, cim);

                telefonok = telefonLetrehozas(temp);
                for (Telefon telefon : telefonok) {
                    szemely.telefontVesz(telefon);
                }

                szemelyek.add(szemely);
            }
        }
    }

    private Cim cimLetrehozas(JSONObject obj) {
        Cim cim;
        JSONObject temp = obj.getJSONObject(Cim.CSOMOPONT_NEV);
        String varos = temp.getString(Cim.VAROS_NEV);
        String utca = temp.getString(Cim.UTCA_NEV);
        int hazSzam = temp.getInt(Cim.HAZ_SZAM_NEV);
        cim = new Cim(varos, utca, hazSzam);

        return cim;
    }


    private List<Telefon> telefonLetrehozas(JSONObject obj) {
        List<Telefon> telefonok = new ArrayList<>();
	JSONArray array = obj.getJSONArray(Telefon.CSOMOPONT_NEV);
        JSONObject temp;
        Telefon.TelefonTipus telefontipus;
        String telefonszam;
        for (int i = 0; i < array.length(); i++) {
            temp = array.getJSONObject(i);
            telefontipus = Telefon.tipusAzElnevezesAlapjan(temp.getString(Telefon.TIPUS_NEV));
            telefonszam = temp.getString(Telefon.SZAM_NEV);
            telefonok.add(new Telefon(telefontipus, telefonszam));
        }
        return telefonok;
    }

    private void kiiratas() {
        System.out.println("A beolvasott adatok: ");
        for (Szemely szemely : szemelyek) {
            System.out.println(szemely);
        }
    }

}
